% Numerik 1, Blatt 1, Aufgabe 1
% Christoph Lange, langec@web.de

function [t, y] = euler_expl(func, t0, tf, y0, h)

% Lsung einer Anfangswertaufgabe y' = f(t,y), y(t0) = y0
% mit dem expliziten Euler-Verfahren im Intervall [t0,tf].
%
% Eingabe:
%
% func    - Funktion f(t,y), die die rechte Seite der
%           Differentialgleichung auswertet.
%	    (inline-Objekt oder Funktionsname als String)
% h       - Schrittweite
%
% Ausgabe:
%
%   y - Vektor, dessen j. Komponenten die berechnete Nherung an
%       y(t+jh) enthlt.

N = round((tf - t0)/h);
t = t0:h:tf;
y = zeros(N+1, 1);
y(1) = y0;
for k = 1:N
  y(k+1) = y(k) + h * feval(func, t(k), y(k));
end
